unit iMisc;

interface

uses
    Windows, Messages, Forms, Graphics;

//  ---------------------------------------------------------------------------
const
    CUR_SEEKER = 1;
    CURSEEK = 'CUR_SEEK';
    BMP_NONE = 'BMP_BURSTCLICK';
    BMP_LOCK = 'BMP_LOCKON';
    BMP_LOST = 'BMP_TARGETLOST';
const
    MODE_NONE     = 0;
    MODE_LOCKON   = 1;
    MODE_LOST     = 2;
//  ---------------------------------------------------------------------------
const
    //  ʒmpEBhEbZ[W(DLL to EXE)
    UM_DESTROYWND  = WM_APP + 1001; //  CBTProc(in DLL)
    UM_LMOUSEUP    = WM_APP + 1002; //  MouseProc(in DLL)
    UM_RMOUSEUP    = WM_APP + 1003; //  MouseProc(in DLL)

const
    HOOK_DLL_NAME  = 'hook.dll';
//  ---------------------------------------------------------------------------
//  DLLC|[gEăX^eBbNN
function    HookInstall(Wnd: HWND): Boolean; stdcall;external HOOK_DLL_NAME;
procedure   HookUnInstall(); stdcall;external HOOK_DLL_NAME;
procedure   HookInitialize(); stdcall;external HOOK_DLL_NAME;
procedure   HookFinalize(); stdcall;external HOOK_DLL_NAME;

//  ---------------------------------------------------------------------------
function GetClassNameStr(const hWindow:HWND):string;
function GetWindowTextStr(const hWindow:HWND):string;
function GetMostTopLevelWindow(const hWindow:HWND):HWND;
//  ---------------------------------------------------------------------------
procedure FlashDesktopCanvas(const Target: HWND; const Interval: integer);
procedure FlashDesktopCanvas2(const Target: HWND; const Interval: integer);
//  ---------------------------------------------------------------------------
function SimulateClick(const Target: HWND; const Interval: integer): Boolean;

implementation

{$R Extra.res}

//  ---------------------------------------------------------------------------
//  R[hŃNbN
function SimulateClick(const Target: HWND; const Interval: integer): Boolean;
var
    Point: TPoint;
    RT: TRect;
    WI: TWindowInfo;
begin
    //  J[\̈ʒu擾
    GetCursorPos(Point);
    //  EBhE擾
    Result := GetWindowInfo(Target, WI);
    //  nhH
    if (not Result) then exit;
    //  ̈擾
    RT := WI.rcWindow;
    //  NbNʒu
    if PtInRect(RT, Point) then
    begin
        //  NbNʒu^[QbgWɕϊ
        Point.X := Point.X - RT.Left;
        Point.Y := Point.Y - RT.Top;
        //  {^E
        PostMessage(Target, WM_LButtonDown, 0, MakeLong(Point.X, Point.Y));
        PostMessage(Target, WM_LButtonUp, 0, MakeLong(Point.X, Point.Y));
//        SendMessage(Target, WM_LButtonDown, 0, MakeLong(Point.X, Point.Y));
//        SendMessage(Target, WM_LButtonUp, 0, MakeLong(Point.X, Point.Y));
        //  ҂
        Sleep(Interval);
    end;
end;

//  ---------------------------------------------------------------------------
//  w肵nhEBhẺ`悷
procedure FlashDesktopCanvas(const Target: HWND; const Interval: integer);
var
    DesktopDC: HDC;
    RT: TRect;
    WI: TWindowInfo;
    DesktopCanvas: TCanvas;
begin
    //  fXNgbṽfoCXReLXg擾
    DesktopDC := GetDC(0);
    if (DesktopDC <> INVALID_HANDLE_VALUE) then
    begin
        DesktopCanvas := TCanvas.Create;
        try
            //  O
            DesktopCanvas.Handle := DesktopDC;
            DesktopCanvas.Pen.Width := 3;
            DesktopCanvas.Pen.Mode := pmNotXor;
            //  EBhE擾
            if GetWindowInfo(Target, WI) then
            begin
                //  NCAg̈擾
                RT := WI.rcWindow;
                //  fXNgbvɋ``(XOR)
                DesktopCanvas.Rectangle(RT);
                //  ΂҂
                Sleep(Interval);
                //  fXNgbvɋ``(XOR)
                DesktopCanvas.Rectangle(RT);
            end;
        finally
            //  fXNgbṽfoCXReLXgj
            DesktopCanvas.Free;
            ReleaseDC(0, DesktopDC);
        end;
    end;
end;

//  ---------------------------------------------------------------------------
//  w肵nhEBhEǂꂩĂ݂
procedure FlashDesktopCanvas2(const Target: HWND; const Interval: integer);
var
    CurHandle: HWND;
begin
    CurHandle := GetForegroundWindow();
    //  Oɏo
    if SetForegroundWindow(Target) then
    begin
        //  Ƒ҂(ꂪȂƕ`悪݂)
        Sleep(Interval);
        //  
        FlashDesktopCanvas(Target, Interval);
        //  Ƒ҂
        Sleep(Interval);
    end;
    //  ɖ߂
    SetForegroundWindow(CurHandle);
end;

//  ---------------------------------------------------------------------------
//  NX擾
//  ---------------------------------------------------------------------------
//  Win32 API by Object Pascal of Delphi
//  http://homepage2.nifty.com/Mr_XRAY/Halbow/VCL06.html#VChap6-7
function GetClassNameStr(const hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  GetMem(p,100);
  ret := GetClassName(hWindow,p,100);
  SetString(result,p,ret);
  FreeMem(p);
end;

//  ---------------------------------------------------------------------------
//  EBhEeLXg擾
function GetWindowTextStr(const hWindow:HWND):string;
var
  p:PChar;
  ret:integer;
begin
  ret := GetWindowTextLength(hWindow);
  GetMem(p,ret+1);
  ret := GetWindowText(hWindow,p,ret+1);
  SetString(result,p,ret);
  FreeMem(p);
end;

//  ---------------------------------------------------------------------------
//  EBhE̍ŏĩEBhE擾
function GetMostTopLevelWindow(const hWindow:HWND):HWND;
var
  hAncestor,hPrev:HWND;
begin
  hPrev := hWindow;
  hAncestor := GetParent(hPrev);
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetParent(hPrev)
  end;
  hAncestor := hPrev;
  while hAncestor <> 0  do begin
    hPrev := hAncestor;
    hAncestor := GetWindow(hPrev,GW_OWNER)
  end;
  result := hPrev;
end;

//  ---------------------------------------------------------------------------
//  
initialization
    //  J[\Ǎ
    Screen.Cursors[CUR_SEEKER] := LoadCursor(HInstance, CURSEEK);
finalization
    ;
end.

